! File: pthreads.sparc/parmacs_tas.s
! Description: Low Level Test and Set Implementation
! Department of Computer Architecture - Polytechnic University of Catalonia-UPC
!
! Disclaimer and copying policy:
! 
!  The Polytechnic University of Catalonia (UPC) and the authors disclaim
!  all warranties with regard to this software, including all implied
!  warranties of merchantability and fitness.
!  In no event shall the Polytechnic University of Catalonia (UPC) or the
!  authors be liable for any special, indirect or consequential damages or
!  any damages whatsoever resulting from loss of use, data or profits,
!  whether in an action of contract, negligence or other tortius action,
!  arising out of or in connection with the use or performance of this
!  software.
! 
!  Permission to use, copy, modify, and distribute this software for
!  any purpose and without fee is hereby granted, provided that the above
!  copyright notice and disclaimer, and also this permission notice, appear
!  in all copies.
!
! 
! Prototypes:
! 
! unsigned long parmacs_tas(unsigned long *, unsigned long);
! unsigned long parmacs_atmc_add(unsigned long *, unsigned long);
!
	
	.section	".text",#alloc,#execinstr
	.align	8	
	.global tas
	.volatile
	.type   tas,2
	.global fas
	.type   fas,2

tas:
fas:
        retl
	ldstub	[%o0], %o0	! delay slot
	.size	tas,(.-tas) 
	

! atmc_add(unsigned lont *, int)
	.global atmc_add
	.align  8
	.type 	atmc_add,2
atmc_add:	
	ld	[%o0],%o2
	or	%o1,%g0,%o3
.rep:
	add	%o2,%o3,%o1
	cas	[%o0],%o2,%o1
	cmp	%o1,%o2
	bne,pn	%icc,.rep
	or	%o1,%g0,%o2
	membar	#StoreLoad
	retl
	or	%o2,%g0,%o0	
	.size	atmc_add,(.-atmc_add)


